#include <PSX/System/IOPorts/interrupt_io.hpp>
#include <PSX/System/IOPorts/timer_io.hpp>
#include <PSX/System/syscalls.h>

namespace JabyEngine {
    namespace Timer {
        extern InterrupCallback IRQCallback;

        void setup() {
            static constexpr auto     Mode   = CounterMode::with(CounterMode::FreeRun, Counter2::SyncMode::Freerun, CounterMode::ResetAfterTarget, CounterMode::IRQAtTarget, CounterMode::IRQEveryTime, Counter2::Source::System_Clock_Div_8);
            static constexpr uint16_t Target = 0x1234;

            //Counter[2].target.ref().set(CounterTarget::CounterTargetValue.with(Target));

            __syscall_EnterCriticalSection();
            __syscall_SysEnqIntRP(Timer2Irq, &IRQCallback);
            __syscall_ExitCriticalSection();
            Interrupt::enable_irq(Interrupt::Timer2);
        }
    }
}