#define private public
#include <PSX/System/IOPorts/interrupt_io.hpp>
#include <PSX/System/syscalls.h>
#include <PSX/Timer/timer.hpp>
#undef private

namespace JabyEngine {
    size_t GlobalTime :: global_counter = 0;

    namespace Timer {
        InterruptVerifierResult interrupt_verifier() {
            const auto irq_status = Interrupt::Status.read();

            if(Interrupt::is_irq(Interrupt::Timer2)) {
                return InterruptVerifierResult::ExecuteHandler;
            }
            
            else {
                return InterruptVerifierResult::SkipHandler;
            }
        }

        uint32_t interrupt_handler(uint32_t) {
            GlobalTime::global_counter++;

            Interrupt::ack_irg(Interrupt::Timer2);
            __syscall_ReturnFromException();
        }

        InterrupCallback IRQCallback = {
            .next              = nullptr,
            .handler_function  = interrupt_handler,
            .verifier_function = interrupt_verifier
        };
    }
}